workflow:
  rules:
    - if: $CI_COMMIT_BRANCH != "main" && $CI_PIPELINE_SOURCE != "merge_request_event"      
      when: never
    - when: always

stages:
    - "test"
    - "build"
    - "deploy"

run_unit_tests:
    stage: test
    before_script:
     - echo "preparing test data"
    script: 
     - echo 'running unit tests'
    after_script:
     - echo 'cleaning up temporary files'

run_lint_tests:
    stage: test
    before_script:
     - echo "preparing test data"
    script: 
     - echo 'running lint tests'
    after_script:
     - echo 'cleaning up temporary files'

build_image:
    only:
        - main
    stage: build
    script: 
     - echo 'building the docker image'
     - echo 'tagging the docker image'


push_image:
    only:
        - main
    stage: build
    needs:
        - build_image
    script:
     - echo 'logging into docker registry ...'
     - echo 'pushing docker image'

deploy_image:
    only:
        - main
    stage: deploy
    script:
     - echo 'deploying new docker image to dev server...'
